Description

After adding two flexform items to a record, and selecting all 3 checkboxes on the bottom item, and saving the form the flexform data
of the record gets corrupted. The record is then no longer accesible through the typo3 backend, and the only way to fix it is manually
editing the record from the database with phpmyadmin, or deleting the record.

I first noticed this bug in the slideshow extension, but it looks like it can be trigged by all extensions which uses this kind of flexforms.

I have made a test exteion to reproduce the effect.

1. Install the test_flexform extension.
2. Add a new "flexform items" record to a sysfolder.
3. Select NEW "flexform item" and save the form.
4. Select NEW "flexform item" again and save the form again.
5. Select all 3 checkboxes beside the bottom flexform item (the delete, move up, and move down icons), and save the form.

After saving the form the flexform data in the record becomes corrupted, and PHP produces the following error:

PHP Fatal error:  Cannot use string offset as an array in <sitedirectory>/typo3_src-4.1.5/t3lib/class.t3lib_transferdata.php on line 625

After following the previous steps, the flexform data in the record contains an empty element, which typo3 can't handle correctly:

<T3FlexForms>
    <data>
        <sheet index="sDEF">
            <language index="lDEF">
                <field index="fields">
                    <el index="el">
                        <section index="1"></section>
                        <section index="2">
                            <itemType index="item">
                                <el>
                                    <field index="item">
                                        <value index="vDEF"></value>
                                    </field>
                                </el>
                            </itemType>
                        </section>
                    </el>
                </field>
            </language>
        </sheet>
    </data>
</T3FlexForms>

The steps I have written down are not the only way to reproduce this bug, other combinations of adding / deleting / moving items will
sometimes cause it too.
(issue imported from #M7235)

Related issues:
related to Core - Bug # 18690: Creating and editing of fields, forms, etc. in... Closed 2008-04-24

History
#1 - 2008-01-22 11:34 - Emiel Nijpels

Another way to trigger this bug, while using only 1 checkbox at a time:

1. Create 3 items in the flexform.
2. Click the delete button next to the 2nd item, and save the flexform.
3. Click the move up button next to the last item and save the flexform.

The XML data in the database record for the flexform is then set to:

<T3FlexForms>
    <data>
        <sheet index="sDEF">
            <language index="lDEF">
                <field index="fields">
                    <el index="el">
                        <section index="1">
                            <itemType index="item">
                                <el>
                                    <field index="item">
                                        <value index="vDEF"></value>
                                    </field>
                                </el>
                            </itemType>
                        </section>
                        <section index="3"></section>
                        <section index="2">
                            <itemType index="item">
                                <el>
                                    <field index="item">
                                        <value index="vDEF"></value>
                                    </field>
                                </el>
                            </itemType>
                        </section>
                    </el>
                </field>
            </language>
        </sheet>
    </data>
</T3FlexForms>

And the flexform record can no longer be accessed through the typo3 backend, because of the php fatal error.

#2 - 2008-01-22 14:54 - Emiel Nijpels

I have added a patch, which seems to fix the bug. Can someone else please verify this?

#3 - 2008-09-12 14:04 - Raffi no-lastname-given

The bug 0008232 is still not resolved in TYPO3 version 4.2.1, why is it set to resolved? When do this two bugs go into the core version?

#4 - 2011-09-05 00:04 - Andreas Wolf
- Status changed from New to Closed
- Target version deleted (0)

Closing this as the checkboxes are not present in recent core versions anymore.

Files
T3X_test_flexform-0_0_0-z-200801211446.t3x 9.6 kB 2008-01-21 Administrator Admin
bug_7235.diff 1.5 kB 2008-01-22 Administrator Admin
